/**************************************************************
 * RobotDefs.h 
 *
 * Copyright (C) 2002 - Pacific Star Technologies Ltd 
 * All Rights Reserved. Unauthorized dissemination of this file
 * is strictly prohibited.
 *
 * Created: Jul 24, 2002 
 *************************************************************/
#ifndef ROBOTDEFS_H_
#define ROBOTDEFS_H_

#ifdef __cplusplus
extern "C" {
#endif

#define RC_OK                    0
#define RC_TIMEOUT               1
#define RC_FAIL                  2
#define RC_INVALIDARG            3

typedef unsigned int    RCResult;
typedef void *          HROBOT;
typedef void *          HCGROUP;

// Enumerations
typedef enum {
  RCMS_FAST = 0,
  RCMS_SLOW,
  RCMS_STOP
} RCMoveSpeed;

typedef enum {
  RCMD_NONE = 0,
  RCMD_NORTH,
  RCMD_SOUTH,
  RCMD_EAST,
  RCMD_WEST,
  RCMD_NE,
  RCMD_NW,
  RCMD_SE,
  RCMD_SW
} RCMoveDir;

typedef enum {
  RCS_LEFT = 0,
  RCS_RIGHT
} RCSide;

typedef enum {
  RCD_UP = 0,
  RCD_DOWN,
  RCD_FORWARD,
  RCD_BACKWARD,
  RCD_STOP
} RCDirection;

typedef enum {
  RCOM_UNKNOWN = 0,
  RCOM_INIT,
  RCOM_OFF,
  RCOM_REMOTE,
  RCOM_MONITOR,
  RCOM_AUTO,
  RCOM_GREET,
  RCOM_SENTRY,
  RCOM_STANDBY
} RCOpMode;

typedef enum {
  RCC_CH1,
  RCC_CH2,
  RCC_CH3,
  RCC_UNKNOWN
} RCChannel;

typedef enum {
  RCLM_UNKNOWN,
  RCLM_OFF,
  RCLM_LOW,
  RCLM_HIGH
} RCLightMode;

typedef enum {
  RCV_OFF = 0,
  RCV_VOL1,
  RCV_VOL2,
  RCV_VOL3,
  RCV_VOL4,
  RCV_VOL5
} RCVolume;

typedef struct {
  RCOpMode opMode;
  unsigned char batteryLevel;
  RCChannel videoChannel;
  RCChannel controlChannel;
  RCLightMode lightMode;
  unsigned char charging;
  unsigned char batteryFull;
  unsigned char carrier;
  unsigned char armLocked;
  unsigned char USBbusy;
  unsigned char USBvalid;
  unsigned char error;
} RCStatus;

#ifdef __cplusplus
}
#endif // ifdef __cplusplus
#endif // ifndef ROBOTDEFS_H_
