/**************************************************************
 * RobotEvent.h 
 *
 * Copyright (C) 2002 - Pacific Star Technologies Ltd 
 * All Rights Reserved. Unauthorized dissemination of this file
 * is strictly prohibited.
 *
 * Created: Aug 2, 2002 
 *************************************************************/
#ifndef ROBOTEVENT_H_
#define ROBOTEVENT_H_

#include <windows.h>
#include <ole2.h>

#define INVALID_EVENT_ID                0

DECLARE_INTERFACE_(IRbtEventSink, IUnknown)
{
  STDMETHOD(QueryInterface) (THIS_ REFIID, void **) PURE;
  STDMETHOD_(ULONG, AddRef) (THIS) PURE;
  STDMETHOD_(ULONG, Release) (THIS) PURE;

  STDMETHOD(NewEvent) (THIS_ LPCTSTR) PURE;
  STDMETHOD(RemoveEvent) (THIS_ LPCTSTR) PURE;
  STDMETHOD(NewModule) (THIS_ IUnknown *) PURE;
  STDMETHOD(RemoveModule) (THIS_ IUnknown *) PURE;
};

DECLARE_INTERFACE_(IRbtCustomSink, IUnknown)
{
  STDMETHOD(QueryInterface) (THIS_ REFIID, void **) PURE;
  STDMETHOD_(ULONG, AddRef) (THIS) PURE;
  STDMETHOD_(ULONG, Release) (THIS) PURE;

  STDMETHOD(DispatchEvent) (THIS_ DWORD, DWORD) PURE;
};

typedef struct {
  WCHAR name[64];
  DWORD id;
  DWORD antiID;
} EVENTDATA;

DECLARE_INTERFACE_(IEnumRbtEvents, IUnknown)
{
  STDMETHOD(QueryInterface) (THIS_ REFIID, void **) PURE;
  STDMETHOD_(ULONG, AddRef) (THIS) PURE;
  STDMETHOD_(ULONG, Release) (THIS) PURE;

  STDMETHOD(Reset) (THIS) PURE;
  STDMETHOD(Next) (THIS_ ULONG, EVENTDATA *, ULONG *) PURE;
  STDMETHOD(Skip) (THIS_ ULONG);
  STDMETHOD(Clone) (THIS_ IEnumRbtEvents **) PURE;
};

#endif
