/**************************************************************
 * ObjFactory.h 
 *
 * Copyright (C) 2002 - Pacific Star Technologies Ltd
 * All Rights Reserved. Unauthorized dissemination of this file
 * is strictly prohibited.
 *
 * Created: Nov 04, 2002
 *************************************************************/
#ifndef OBJFACTORY_H_
#define OBJFACTORY_H_

#include <windows.h>

class CModFactory : public IUnknown 
{
public:
  CModFactory(IUnknown *pOuter);
  ~CModFactory();

  STDMETHODIMP QueryInterface(REFIID, void **);
  STDMETHODIMP_(ULONG) AddRef();
  STDMETHODIMP_(ULONG) Release();

private:
  class CModFactImpl : public IClassFactory
  {
  public:
    CModFactImpl(IUnknown *pOuter, CModFactory *pBack);
    ~CModFactImpl();
    
    STDMETHODIMP QueryInterface(REFIID, void **);
    STDMETHODIMP_(ULONG) AddRef();
    STDMETHODIMP_(ULONG) Release();

    STDMETHODIMP CreateInstance(IUnknown *, REFIID, void **);
    STDMETHODIMP LockServer(BOOL);

  private:
    UINT refCnt;
    CModFactory *parent;
    IUnknown *outer;
  };

  
  IUnknown *out;
  UINT refCnt;
  CModFactImpl child;
};

class CPropFactory : public IUnknown
{
public:
  CPropFactory(IUnknown *pOuter, CLSID which);
  ~CPropFactory();

  STDMETHODIMP QueryInterface(REFIID iid, void **ppv);
  STDMETHODIMP_(ULONG) AddRef();
  STDMETHODIMP_(ULONG) Release();

private:
  class CPropImpl : public IClassFactory
  {
  public:
    CPropImpl(IUnknown *pOuter, CPropFactory *pBack);
    ~CPropImpl();

    STDMETHODIMP QueryInterface(REFIID iid, void **ppv);
    STDMETHODIMP_(ULONG) AddRef();
    STDMETHODIMP_(ULONG) Release();

    STDMETHODIMP CreateInstance(IUnknown *pUnk, REFIID iid, void **ppv);
    STDMETHODIMP LockServer(BOOL lock);

  private:
    IUnknown *outer;
    CPropFactory *parent;
  };

  friend class CPropImpl;

  CLSID page;
  IUnknown *outer;
  UINT refCnt;
  CPropImpl child;
};

#endif
