/**************************************************************
 * PropPage.h 
 *
 * Copyright (C) 2002 - Pacific Star Technologies Ltd 
 * All Rights Reserved. Unauthorized dissemination of this file
 * is strictly prohibited.
 *
 * Created: Nov 04, 2002 
 *************************************************************/
#ifndef PROPPAGE_H_
#define PROPPAGE_H_

#include "Module.h"

// TODO: Change this CLSID
// {F8DBBABA-7615-4324-B419-B0BCBEB87119}
DEFINE_GUID(CLSID_PropPage1, 
    0xf8dbbaba, 0x7615, 0x4324, 0xb4, 0x19, 0xb0, 0xbc, 0xbe, 0xb8, 0x71, 0x19);

class PropPage : public IPropertyPage
{
public:
  PropPage(UINT templ, UINT title, UINT doc, UINT ctx);
  virtual ~PropPage();
  
  STDMETHODIMP QueryInterface(REFIID iid, void **ppv);
  STDMETHODIMP_(ULONG) AddRef();
  STDMETHODIMP_(ULONG) Release();
 
  STDMETHODIMP SetPageSite(IPropertyPageSite *pageSite);
  STDMETHODIMP GetPageInfo(PROPPAGEINFO *pageInfo);
  STDMETHODIMP Activate(HWND hwnd, LPCRECT rect, BOOL modal);
  STDMETHODIMP Deactivate();
  STDMETHODIMP SetObjects(ULONG numObjs, IUnknown **pObjs);
  STDMETHODIMP Show(UINT nCmd);
  STDMETHODIMP Move(LPCRECT rect);
  STDMETHODIMP IsPageDirty();
  STDMETHODIMP Help(LPCOLESTR helpDir);
  STDMETHODIMP TranslateAccelerator(LPMSG pMsg);

  virtual INT_PTR DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) = 0;

private:
  LPTSTR rsrc;
  WCHAR title[32];
  WCHAR docString[64];
  UINT helpCtx;
  
protected:
  bool dirty;
  ULONG refCnt;
  IPropertyPageSite *site;

  //TODO: Replace with name of interface used to access module's properties
  IRbtModuleName *module;
  IRobot *pRobot;
  HWND page;
};

class PropPage1 : public PropPage
{
public:
  PropPage1();
  virtual ~PropPage1();
  
  STDMETHODIMP Apply();
  virtual INT_PTR DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
};

#endif 
